Bug 19298

Summary: mod_jk2 and Apache2 broken autoindex
Product: Tomcat Connectors Reporter: marcs
Component: CommonAssignee: Tomcat Developers Mailing List <dev>
Status: RESOLVED WONTFIX    
Severity: enhancement CC: ivanfm, simpsonb
Priority: P3    
Version: unspecified   
Target Milestone: ---   
Hardware: Other   
OS: other   

Description marcs 2003-04-24 23:32:31 UTC
I have apache setup with:

DirectoryIndex index.jsp

I have mod_jk2 setup with:

[uri:/*.jsp]

The result is requests for index.jsp or for a directory with an index.jsp are
properly forwarded to tomcat, however if I request a directory with no index.jsp
file in that I want to have mod_autoindex handle, then mod_jk2 still forwards
that to tomcat which returns an error because there is no index file.

There needs to be support for forwarding using handlers, which would allow you
to properly configure a Files directive to handle them with a SetHandler. 
Apache should be the one to figure out if the file exists.  Another symptom of
this same problem is requesting /foo.jsp where foo.jsp doesn't exist.  Apache
should be the one returning a 404, not tomcat.

I want Apache to be the one deciding what should be handled when I am using its
configuration directives.  Using Location-style directives is a horrible idea
for such things as it is a security issue when you have various names that can
refer to the same file, eg. Windows.  As the Apache documentation clearly
states, Location directives should not be used to control access to files on
disk but should only be used for true virtual namespaces.
Comment 1 Mark Thomas 2004-04-14 20:48:01 UTC
This reads like an enhancement request to me.
Comment 2 Brett Simpson 2004-05-10 16:42:45 UTC
I'm also seeing this problem.  
Is there any idea on when this will be added/corrected?  
How about any CVS code that resolves the problem? 
 
Thanks 
Comment 3 Ivan F. Martinez 2004-06-03 21:25:49 UTC
same problem here
Comment 4 Mark Thomas 2004-06-19 11:47:27 UTC
This enhancement request has been transferred to Tomcat 5 because:
- TC4 and TC5 share the connectors
- TC4 is no longer being developed, only supported
Comment 5 Yoav Shapira 2004-11-29 19:50:30 UTC
As of November 15, 2004, JK2 is no longer supported. All bugs related to JK2 
will be marked as WONTFIX. In its place, some of its features have been 
backported to jk1. Most of those features will be seen in 1.2.7, which is 
slated for release on November 30th, 2004.

Another alternative is the ajp addition to mod_proxy which will be part of 
apache 2.

For more information on the Tomat connectors docs at
http://jakarta.apache.org/tomcat/connectors-doc/